import java.io.*;
import java.util.*;

class Sovrapposizione extends Exception {
}
class AttrezzoinUso extends Exception {
}

public class Manager extends IOException {

	/* nome , lista usi */
	static HashMap attrezzi = new HashMap();

	static HashMap persone = new HashMap();
	static Persona persona;

	public static void main(String[] args) {

		try {
			BufferedReader br =
				new BufferedReader(new InputStreamReader(System.in));
			String c;
			int caso = 1;
			menu(caso);

			while ((c = br.readLine()).equalsIgnoreCase("e") == false) {
				switch (caso) {
					case 1 :
						{
							if ((persona = (Persona) persone.get(c)) == null) {
								/* se non esiste crea nuova persona */
								persona = new Persona(c);
							}
							System.out.println(
								"Benvenuto " + persona.getNome());
							caso = 2;
							menu(caso);
							break;
						}
					case 2 :
						{
							Sovrapposizione s = new Sovrapposizione();
							AttrezzoinUso A = new AttrezzoinUso();

							try {

								String nome, attrezzo;
								Attrezzo a;
								int oraInizio, minInizio, durata, inizio;
								System.out.print(
									"Inserisci il nome dell'esercizio> ");
								nome = br.readLine();
								System.out.print(
									"Inserisci ora inizio 'HH MM'> ");
								StringTokenizer campo =
									new StringTokenizer(br.readLine());
								oraInizio = Integer.parseInt(campo.nextToken());
								minInizio = Integer.parseInt(campo.nextToken());
								inizio = oraInizio * 60 + minInizio;
								System.out.print("Inserisci durata esercizo> ");
								durata = Integer.parseInt(br.readLine());
								System.out.print(
									"Inserisci il nome dell'esercizio> ");
								attrezzo = br.readLine();
								a = new Attrezzo(inizio, inizio + durata);
								LinkedList usi;
								if ((usi = (LinkedList) attrezzi.get(nome))
									== null) {
									/* caso nuovo attrezzo */
									attrezzi.put(nome, usi);
									Esercizio es =
										new Esercizio(
											nome,
											inizio,
											durata,
											attrezzo,
											persona.getNome());

									if (persona.aggiungiEs(es) == false)
										throw s;
									else {
										usi.add(a);
										System.out.println("Inserimento ok");
										caso = 2;
										menu(caso);
										break;

									}
								} else {
									Iterator l = usi.iterator();
									int k = 0;
									while (l.hasNext()) {
										Attrezzo aa = (Attrezzo) l.next();
										if (aa.utilizzo(inizio))
											throw A;
										else {
											Esercizio es =
												new Esercizio(
													nome,
													inizio,
													durata,
													attrezzo,
													persona.getNome());
											if (persona.aggiungiEs(es)
												== false)
												throw s;
											else {
												usi.add(aa);
												System.out.println(
													"Inserimento ok");
												caso = 2;
												menu(caso);
												break;

											}
										}
									}
								}
							} catch (AttrezzoinUso a) {
								System.out.println("Attrezzo in uso");
							} catch (Sovrapposizione e) {
								System.out.println(
									"Esercizi sovrapposizionati");
							}
						}
				}
			}
			System.out.println("Fine");

		} catch (IOException ioe) {
			System.out.println("I/O error");
		}
	}

	private static void menu(int caso) {
		System.out.println("Digitare e per uscire altrimenti..");
		switch (caso) {
			case 1 :
				{
					System.out.print("Inserisci il tuo nome> ");
					break;
				}
			case 2 :
				{
					System.out.print(
						"Inserimento esercizio... premi INVIO per continuare");
					break;

				}
		}

	}
}
