public class tartaglia {

	/* attributo */
	int[][] triangolo;

	tartaglia() {
		triangolo = new int[100][]; /* allocazione righe */
	}
	public static void main(String[] args) {
		tartaglia t = new tartaglia();
		int n = Integer.parseInt(args[0]);
		t.implementa(n);
		t.stampa(n);
	}

	public void implementa(int n) {
		int r, c;
		for (r = 0; r < n; r++) {
			triangolo[r] = new int[r + 1];
		}
		for (r = 0; r < n; r++) /* for righe */ {
			for (c = 0; c < r; c++) /* for colonne */ {
				if ((c == 0) || (c == r - 1)) {
					triangolo[r][c] = 1;
				} else {
					triangolo[r][c] = 0;
					triangolo[r][c] += triangolo[r
						- 1][c]
						+ triangolo[r
						- 1][c
						- 1];
				}
			}
		}
	}
	public void stampa(int n) {
		int r, c;
		System.out.print("\n");

		for (r = 0; r < n; r++) /* for righe */ {
			for (c = 0; c < r; c++) /* for colonne */ {
				System.out.print(" " + triangolo[r][c]);
			}
			System.out.print("\n");
		}
	}
}
