import java.io.*;
import java.util.*;

public class scaffale {

	private String codice;
	private piano p;
	private LinkedList e;
	private int numelementi;
	private int index;
	scaffale(String CODICE, piano PIANO) {
		e = new LinkedList();
		p = PIANO;
		numelementi = 0;
		codice = CODICE;
	}

	piano getpiano() {
		return this.p;

	}

	String getcodice() {
		return this.codice;

	}

	void addlibro(String AUTORE, String TITOLO) throws IOException {
		if (numelementi < 10) {
			e.add(new libro(AUTORE, TITOLO, this.codice, this.p));
			numelementi++;
		} else {
			IOException errore =
				new IOException("Scaffale " + this.codice + " pieno ");
			throw errore;
		}
	}

	void addcd(String AUTORE, String TITOLO, String GENERE) {
		if (numelementi < 10) {
			e.add(new cd(AUTORE, TITOLO, this.codice, this.p, GENERE));
			numelementi++;
		} else {
			System.out.println("Scaffale " + this.codice + " pieno");
		}
	}

	void addbranoacd(
		String AUTORE,
		String TITOLO,
		int DURATA,
		String TITCANZ) {
		int i = 0;
		Iterator L = e.iterator();
		while (L.hasNext()) {
			Object b = L.next();

			if (b instanceof cd) {
				cd c = (cd) b;
				if (c.getautore().equalsIgnoreCase(AUTORE)
					&& c.gettitolo().equalsIgnoreCase(TITOLO)) {
					c.addbrano(TITCANZ, DURATA);
					e.remove(i);
					e.add(c);
					break;
				}
			}
			i++;
		}
		if (i == numelementi) {
			System.out.println(
				"Non  stato trovato il cd "
					+ TITOLO
					+ " nello scaffale "
					+ this.codice);
		}

	}
	void printAll() {
		Iterator L = e.iterator();
		while (L.hasNext()) {
			Object b = L.next();
			if (b instanceof libro) {
				libro l = (libro) b;
				l.print();
			} else {
				cd c = (cd) b;
				c.print();
			}

		}
	}

	void scarica(BufferedWriter O) throws IOException {
		Iterator L = e.iterator();
		while (L.hasNext()) {
			Object b = L.next();
			if (b instanceof libro) {
				libro l = (libro) b;
				try {
					O.write("1\n");
					O.write(l.getautore() + "\n");
					O.write(l.gettitolo() + "\n");
					O.write(l.getpiano().getcodice() + "\n");
					O.write(l.getscaffale() + "\n");
				} catch (IOException e) {
				}

			} else {
				cd c = (cd) b;
				try {
					O.write("2\n");
					O.write(c.getautore() + "\n");
					O.write(c.gettitolo() + "\n");
					O.write(c.getgenere() + "\n");
					O.write(c.getpiano().getcodice() + "\n");
					O.write(c.getscaffale() + "\n");
					O.write("3\n");
					LinkedList B = c.getbrani();
					Iterator LB = B.iterator();
					while (LB.hasNext()) {
						Object bb = LB.next();
						brano bbb = (brano)bb;
						O.write(c.getautore() + "\n");
						O.write(c.gettitolo() + "\n");
						O.write(bbb.getdurata()+"\n");
						O.write(bbb.gettitolo()+"\n");
						O.write(c.getpiano().getcodice() + "\n");
						O.write(c.getscaffale() + "\n");
					}				
				} catch (IOException e) {
					throw e;
				}
			}

		}

	}

	boolean ricerca(String TITOLO, int CASO) throws IOException {
		boolean k = false;
		Iterator L = e.iterator();

		while (L.hasNext()) {
			Object b = L.next();
			if (CASO == 0) {
				if (b instanceof libro) {
					libro l = (libro) b;
					if (l.gettitolo().equalsIgnoreCase(TITOLO)) {
						k = true;
						l.print();
						return k;
					}
				} else {
					cd c = (cd) b;
					if (c.gettitolo().equalsIgnoreCase(TITOLO)) {
						k = true;
						c.print();
						return k;
					}
				}
			} else {
				if (b instanceof cd) {
					cd c = (cd) b;
					if (c.ricerca(TITOLO)) {
						k = true;
						c.print();
						return k;
					}
				}
			}
		}

		//	System.out.println(this.codice);
		IOException errore =
			new IOException(
				"Non  stato nessun libro o cd con questo titolo: " + TITOLO);
		throw errore;
		//return k;
	}
}