import java.util.*;

public class Bibita {
		
		private String nomeB;
		private float prezzoB;	
		private LinkedList colonneConBibita;
		
		public	Bibita(String nome, float prezzo)
		{
			nomeB=nome;
			prezzoB=prezzo;
			colonneConBibita = new LinkedList();
		}
		
		String getNome()
		{
		return nomeB;
		}
		
		float getPrezzo()
		{
		return prezzoB;
		}

		void aggiungiColonna(Colonna c)
		{
		colonneConBibita.add(c);
		}		
		
		void rimuoviColonna(Colonna c)
		{
		colonneConBibita.remove(c);
		}
		
		Colonna primaColonnaConBevanda()
		{Iterator lC = this.colonneConBibita.iterator();
			while (lC.hasNext()) {
				Colonna c= (Colonna) lC.next();
				if(c.getQuantit()>0)
					return c;
			}
			
			return null;
		}
}
