public class StudentSet {

	/*
	 * ATTRIBUTI
	 */

	private Student head = null; //primo elem della lista

	/*
	 * METODI
	 */

	//funzionalita'

	public void add(Student s) {

/* inserisco gi in modo ordinato */
		int i = 0;
		Student temp1 = head;

		if (head == null) {
			head = s;
			s.setNext(null);
		} else {
			Student temp2 = head.getNext();
			do {
				if (s.getCode() < temp1.getCode()) {
					temp1.append(s);
					if(head==temp1)
						{head=s;}
					i = 1;
				} else {
					if (temp2 == null) {
						temp2 = s;
						s.setNext(null);
						temp1.setNext(temp2);
						i = 1;
					} else {
						if (s.getCode() < temp2.getCode()) {
							s.setNext(temp1.getNext());
							temp1.setNext(s);
							i = 1;
						} else {
							temp1 = temp1.getNext();
							temp2 = temp2.getNext();
						}
					}
				}
			} while (i != 1);
		}
	}
	public boolean update(int code, double newMark) {

		boolean ok = false;

		Student temp1 = head;
		int i = 0;
		do {
			if (temp1.whois(code)) {
				temp1.setMark(newMark);
				i = 1;
				ok = true;
			}
			temp1 = temp1.getNext();
			if (temp1 == null) {
				i = 1;
			}
		} while (i != 1);
		return ok;
	}

	public void print(int code) {

		Student temp1 = head;

		while (temp1 != null) {
			if (temp1.whois(code)) {
				temp1.print();
			}
			temp1 = temp1.getNext();
		}
	}

	public void print() {
		Student temp1 = head;

		while (temp1 != null) {
			temp1.print();
			temp1 = temp1.getNext();
		}
	}
}

class Student {

	/*
	 * ATTRIBUTI
	 */

	private String nome; // nome
	private String cognome; //cognome
	private int code; //matricola
	private double mark; //media
	private Student next = null; //successivo nella lista

	/*
	 * METODI
	 */

	//costruttore
	public Student(String first, String last, int code2, double mark2) {

		cognome = last;
		nome = first;
		code = code2;
		mark = mark2;

	}
	public Student() {
	}
	//setters
	void setMark(double mark) {
		this.mark = mark;
	}

	void setNext(Student s) {
		this.next = s;
	}

	//getters
	int getCode() {
		return this.code;
	}

	Student getNext() {
		return this.next;
	}

	//stampa
	void print() {
		System.out.println(
			"Nome: "
				+ this.nome
				+ " Cognome: "
				+ this.cognome
				+ " Matricola: "
				+ this.code
				+ " Media: "
				+ this.mark);
	}

	//attacca un nuovo studente a "next"
	void append(Student s) {
		s.next = this;
	}
	
	// sei tu lo studente?
	boolean whois(int code)
	{if(this.code==code)
		{return true;}
	 else
		{return false;} 		
	}

}
