import java.util.*;

public class StudentSet {

	Vector V;
	int i;

	StudentSet() {
		V = new Vector(10);
	}

	/* inserimento ordinato */
	public void adds(Student s) {
		Iterator l = V.iterator();
		if (i == 0) {
			V.add(0, s);
			i++;
			return;
		}
		int z = 0;
		while (l.hasNext()) {
			Student temp = (Student) l.next();
			if (temp.getCode() < s.getCode()) {
				int k = i-1;
				for (; k> z; k--);
				{
					V.add(k + 1, V.get(k));
				}
				V.set(z, s);
				i++;
				return;
			} else {
				z++;
			}
		}
		V.addElement(s);
		i++;
		return;
	
	}

	public boolean update(int code, double newMark) {
		Iterator l = V.iterator();

		while (l.hasNext()) {
			Student temp = (Student) l.next();
			if (temp.whois(code)) {
				temp.setMark(newMark);
				return true;
			}
		}
		return false;
	}

	public void print(int code) {

		Iterator l = V.iterator();
		while (l.hasNext()) {
			Student temp = (Student) l.next();
			if (temp.whois(code)) {
				temp.print();
			}
		}
	}

	public void print() {

		Iterator l = V.iterator();

		while (l.hasNext()) {
			Student temp = (Student) l.next();
			temp.print();
		}
	}
}

class Student {

	/*
	 * ATTRIBUTI
	 */

	private String nome; // nome
	private String cognome; //cognome
	private int code; //matricola
	private double mark; //media
	private Student next = null; //successivo nella lista

	/*
	 * METODI
	 */

	//costruttore
	public Student(String first, String last, int code2, double mark2) {

		cognome = last;
		nome = first;
		code = code2;
		mark = mark2;

	}
	public Student() {
	}
	//setters
	void setMark(double mark) {
		this.mark = mark;
	}

	void setNext(Student s) {
		this.next = s;
	}

	//getters
	int getCode() {
		return this.code;
	}

	Student getNext() {
		return this.next;
	}

	//stampa
	void print() {
		System.out.println(
			"Nome: "
				+ this.nome
				+ " Cognome: "
				+ this.cognome
				+ " Matricola: "
				+ this.code
				+ " Media: "
				+ this.mark);
	}

	// sei tu lo studente?
	boolean whois(int code) {
		if (this.code == code) {
			return true;
		} else {
			return false;
		}
	}

}
