import java.io.*;
import java.util.*;

public class Votazione {

	static HashMap elettori = new HashMap();
	static int votanti = 0;
	static int dirittoVoto = 0;
	static	int SI = 0;
	static	int NO = 0;

	public static void main(String[] args) throws IOException {
		try {
			

			String nomeFile = args[0];
			caricaElettori(nomeFile);

			BufferedReader in =
				new BufferedReader(new InputStreamReader(System.in));
			String riga;

			int caso = 1;
			System.out.print("Inserire il codice fiscale> ");
			Elettore el=null;

			while ((riga = in.readLine()).equalsIgnoreCase("c")==false) {
				switch (caso) {
					case 1 :
						{
							el = (Elettore) (elettori.get(riga));
							if (el != null) {
								System.out.println(
									"Benvenuto signor "
										+ el.getNome()
										+ " "
										+ el.getCognome());
								System.out.print(
									"Inserire il codice PIN(5 cifre)> ");
								caso = 2;
							} else {
								System.out.println(
									"Codice Fiscale errato o comunque non di un Elettore");
								caso = 1;
								System.out.print(
									"Inserire il codice fiscale> ");
							}
						break;
						}
						
					case 2 :
						{
							if (Long.parseLong(riga) == el.getPin()) {
								if (el.haGiaVotato()) {
									System.out.println("Lei ha gi votato");
									caso = 1;
									System.out.print(
										"Inserire il codice fiscale> ");
								} else {
									System.out.println("Scelga il suo voto:");
									System.out.println("1 - SI");
									System.out.println("2 - NO");
									System.out.print("Il suo voto> ");
									caso = 3;
								}
							} else {
								System.out.println("Il suo PIN  errato");
								System.out.print(
									"Inserire il codice PIN(5 cifre)> ");
							}
						break;
						}
						
					case 3 :
						{
							switch (Integer.parseInt(riga)) {
								case 1 :
									{
										SI++;
										el.haVotato();
										System.out.println(
											"Arrivederci e grazie");
										System.out.println(
											"Per salvare i dati e chiudere le elezioni premere c");
										caso = 1;
										System.out.print(
											"Inserire il codice fiscale> ");
										votanti++;
										break;

									}
								case 2 :
									{
										NO++;
										el.haVotato();
										System.out.println(
											"Arrivederci e grazie");
										System.out.println(
											"Per salvare i dati e chiudere le elezioni premere c");
										caso = 1;
										System.out.print(
											"Inserire il codice fiscale> ");
										votanti++;
										break;

									}
								default :
									{
										System.out.println(
											"Votazione non valida");
										System.out.println(
											"Scelga il suo voto:");
										System.out.println("1 - SI");
										System.out.println("2 - NO");
										System.out.print("Il suo voto> ");
										break;
									}

							}
							break;

						}

				}

			}
			
			salvaSdisco();

		} catch (IOException e) {
			System.out.println(e);
		}

	}

	static void caricaElettori(String nomeFileElettori) throws IOException {
		try {
			BufferedReader in =
				new BufferedReader(new FileReader(nomeFileElettori));

			String riga;
			while ((riga = in.readLine()) != null) {
				StringTokenizer temp = new StringTokenizer(riga);
				Elettore e =
					new Elettore(
						temp.nextToken(),
						temp.nextToken(),
						temp.nextToken(),
						Long.parseLong(temp.nextToken()));
				elettori.put(new String(e.getCodiceF()), e);
				dirittoVoto++;

			}
		} catch (IOException e) {
			throw e;
		}
	}
	
	static void salvaSdisco() throws IOException {
	 try {
			BufferedWriter out =new BufferedWriter(new FileWriter("risultati.txt"));
			out.write("Elettori diritto al voto	: "+dirittoVoto);
			out.newLine();
			out.write("Elettori votanti			: "+votanti);
			out.newLine();
			out.write("Numero di SI				: "+SI);
			out.newLine();
			out.write("Numero di NO				: "+NO);
			out.newLine();
			out.write("Numero di schede bianche	: "+(dirittoVoto-SI-NO));
			out.newLine();
			out.flush();
	}
	catch (IOException e) {
			throw e;
		}
	}

}
